--All credit to Bob.
--Bob's Stupid Castbar (aka BSC)
--Config
--Available fonts are ARIALN.ttf, FRIZQT__.ttf, MORPHEUS.ttf, SKURRI.ttf
                                
local font = "Fonts\\FRIZQT__.ttf"
local style = "nil" --OUTLINE MONOCHROME ect

--[[Player castbar]]--
local height = 16
local width = 180
local Point = "CENTER"
local positionX = 0
local positionY = -98
local textsize = height-2 --So the text scales with the Bar height
local Iconsize = 16

--[[target castbar]]--
local height2 = 16
local width2 = 180
local Point2 = "CENTER"
local positionX2 = 0
local positionY2 = 0
local textsize2 = height2-2
local Iconsize2 = 16

--[[focus castbar]]--Size is affected by the toggle option "Larger Focus Frame"
local height3 = 16
local width3 = 120
local Point3 = "TOP"
local positionX3 = 0
local positionY3 = 10
local textsize3 = height3-2
local Iconsize3 = 16
--------------------------------------------------------------------------------------------------
------------------------------------------[[END CONFIG]]------------------------------------------
--------------------------------------------------------------------------------------------------
local cbf = "CastingBarFrame"
local tbf = "TargetFrameSpellBar"
local fbf = "FocusFrameSpellBar"

--Player castbar
_G[cbf]:SetSize(width,height)
_G[fbf.."Border"]:SetSize(240,40)
_G[cbf.."Border"]:SetPoint("TOP", _G[cbf], 0, 15)
_G[cbf.."Border"]:SetTexture(nil)
_G[cbf.."Flash"]:SetSize(240,40)
_G[cbf.."Flash"]:SetPoint("TOP", _G[cbf], 0, 15)
_G[cbf.."Flash"]:SetTexture(nil)
_G[cbf]:SetScale("1.0")
_G[cbf.."Text"]:SetPoint("BOTTOM", _G[cbf], 0, -5)
_G[cbf.."Text"]:SetFont(font, textsize, style)
_G[cbf]:ClearAllPoints()
_G[cbf]:SetPoint(Point, UIParent, positionX, positionY)
_G[cbf].SetPoint = function() end
_G[cbf.."Icon"]:Hide()
_G[cbf.."Icon"]:SetHeight(Iconsize)
_G[cbf.."Icon"]:SetWidth(Iconsize)

--Target Castbar
_G[tbf]:SetSize(width2,height2)
_G[tbf.."Border"]:SetSize(240,40)
_G[tbf.."Border"]:SetPoint("TOP", _G[tbf], 0, 15)
_G[tbf.."Border"]:SetTexture(nil)
_G[tbf.."Flash"]:SetSize(240,40)
_G[tbf.."Flash"]:SetPoint("TOP", _G[tbf], 0, 15)
_G[tbf.."Flash"]:SetTexture(nil)
_G[tbf]:SetScale("1.0")
_G[tbf.."Text"]:SetPoint("BOTTOM", _G[tbf], 0, -2)
_G[tbf.."Text"]:SetFont(font, textsize2, style)
_G[tbf]:ClearAllPoints()
_G[tbf]:SetPoint(Point2, UIParent, positionX2, positionY2)
_G[tbf].SetPoint = function() end
_G[tbf.."Icon"]:Hide()
_G[tbf.."Icon"]:SetHeight(Iconsize2)
_G[tbf.."Icon"]:SetWidth(Iconsize2)

--Focus Castbar
_G[fbf]:SetSize(width3,height3)
_G[fbf.."Border"]:SetSize(240,40)
_G[fbf.."Border"]:SetPoint("TOP", _G[fbf], 0, 15)
_G[fbf.."Border"]:SetTexture(nil)
_G[fbf.."Flash"]:SetSize(240,40)
_G[fbf.."Flash"]:SetPoint("TOP", _G[fbf], 0, 15)
_G[fbf.."Flash"]:SetTexture(nil)
_G[fbf]:SetScale("1.0")
_G[fbf.."Text"]:SetPoint("BOTTOM", _G[fbf], 0, -2)
_G[fbf.."Text"]:SetFont(font, textsize3, style)
_G[fbf]:ClearAllPoints()
_G[fbf]:SetPoint(Point3, FocusFrame, "TOP", positionX3, positionY3)
_G[fbf].SetPoint = function() end
_G[fbf.."Icon"]:Hide()
_G[fbf.."Icon"]:SetHeight(Iconsize3)
_G[fbf.."Icon"]:SetWidth(Iconsize3)

--Castbar timer from thek
_G[cbf].timer = _G[cbf]:CreateFontString(nil)
_G[cbf].timer:SetFont("Fonts\\FRIZQT__.ttf", 12, "THINOUTLINE")
_G[cbf].timer:SetPoint("RIGHT", _G[cbf], "RIGHT", 24, 0)
_G[cbf].update = .1
_G[tbf].timer = _G[tbf]:CreateFontString(nil)
_G[tbf].timer:SetFont("Fonts\\FRIZQT__.ttf", 12, "THINOUTLINE")
_G[tbf].timer:SetPoint("RIGHT", _G[tbf], "RIGHT", 24, 0)
_G[tbf].update = .1
_G[fbf].timer = _G[fbf]:CreateFontString(nil)
_G[fbf].timer:SetFont("Fonts\\FRIZQT__.ttf", 12, "THINOUTLINE")
_G[fbf].timer:SetPoint("RIGHT", _G[fbf], "RIGHT", 24, 0)
_G[fbf].update = .1
hooksecurefunc("CastingBarFrame_OnUpdate", function(self, elapsed)
	if not self.timer then return end
	if self.update and self.update < elapsed then
		if self.casting then
			self.timer:SetText(format("%.1f", max(self.maxValue - self.value, 0)))
		elseif self.channeling then
			self.timer:SetText(format("%.1f", max(self.value, 0)))
		else
			self.timer:SetText("")
		end
		self.update = .1
	else
		self.update = self.update - elapsed
	end
end)
